
#include "io430.h"

#define   RESETVECTORADDR_APP    0xF9FE        //Ӧóλַ
//APP : 4400-F9DF
//BOOT : FA00-FFCF
#define FLASH_PAGE_SIZE			((unsigned int)0x200)
#define APP_START_ADDRESS              ((unsigned int)0x4400)
#define APP_END_ADDRESS                ((unsigned int)0xF9FF)
#define APP_SEG_NUM                    91
/******************************************************************************/
void InitUart(void);
void EraseFlash(unsigned int addr);
void Application(void);
void Update(void);
unsigned char WriteFlash(unsigned int addr,unsigned char *pdata,
                         unsigned char length);
unsigned char ReadFlash(unsigned int waddr);

unsigned char ResetVectorValid(void);
unsigned char AsciiToHex(unsigned char cNum);
void uart_send(const unsigned char *data_point);


//******************************************************************************
// : ,˳صMSMP430Ƭ
// :    :
void main(void)
{
  WDTCTL = WDTPW + WDTHOLD;                 // Stop WDT
  __disable_interrupt();  
//EraseFlash(0);//ӦóFlash
  if(ResetVectorValid()==1)                 // жǷѾعӦó
  {
    Application();                          // ִӦó
  }
  
  Update();                                 // ִ
}

//******************************************************************************
// :Ӧó򣬽PCתƵӦóĸλ
// :  :
void Application(void)
{
  asm(" mov &0xF9FE, PC;");                 // Cеûָ,ʵֵַת
}

//******************************************************************************
// : 
// :   :
void Update(void)
{
  unsigned int i,j;
  unsigned char RecBuf[50];
  unsigned char WriterBuf[16];
  unsigned char RecCnt=0;
  unsigned char RecTemp=0,RxTemp;
  unsigned long Addr=0;
  unsigned char NumberFlag=0;
  //unsigned int Address;
 
  InitUart();                                // ʼ
  
  EraseFlash(0);//ӦóFlash
  
  uart_send("Update Ready !");               // ȷ
  
/* һκΪݽպʹ */
  while(1)
  {
    if(UCA0IFG & UCRXIFG)
    {
      RxTemp=UCA0RXBUF;
      RecBuf[RecCnt++]=RxTemp;
      if(RxTemp==0x0A && RecCnt>0 )
	{
	 if(RecBuf[0]=='q')	//quit
	  {
	   //_NOP();
	   //return;
           asm(" mov &0xF9FE, PC;");    
	   }
	 else if(RecBuf[0]=='@')	//address
	   {
	    i=1;
	    Addr=0;
	    while(1)
	      {
		if(RecBuf[i]<'0')
		  break;
		Addr<<=4;
		Addr+=AsciiToHex(RecBuf[i]);
		i++;
	      }
		//set address here
	    }
	  else //number
	    {
	     RecTemp=0;
	     j=0;
					
	     for(i=0; i<50; i++)
	      {
		if(RecBuf[i]<'0')
		  {
		    if(RecBuf[i]==0x0A)
		      { break;}
		    if(NumberFlag)
		      {  NumberFlag=0;
		       WriterBuf[j++]=RecTemp;
		       }
		  }
	        else if(RecBuf[i]>='0')
		  {
		    RecTemp <<= 4;
		    RecTemp += AsciiToHex(RecBuf[i]);
		    NumberFlag=1;
	          }
	       }
	    if(j>0)
	      {
		//write data
		WriteFlash(Addr,WriterBuf,j);
		Addr += j;
		j=0;
	       }
	    NumberFlag=0;
	    }
		RecCnt=0;
		RxTemp=0;
	}
      if(RecCnt>50)
	{ 
          uart_send("Revice Error!");
	}
    }
  }
}

//******************************************************************************
// : ASCALLתַ
// : unsigned char cNum  ASC-IIַ
// : unsigned char HEX
unsigned char AsciiToHex(unsigned char cNum)
{
	if(cNum>='0'&&cNum<='9')
	{
		cNum -= '0';
	}
	else if(cNum>='A'&&cNum<='F')
	{
		cNum -= 'A';
		cNum += 10;
	}
	return cNum;
}

//******************************************************************************
// :һַPC
// :const unsigned char *data_point ַ
// :
void uart_send(const unsigned char *data_point)
{
  while(1)
  {
    while(!(UCA0IFG&UCTXIFG)); //query tx ready?
    if(*data_point=='\0')
    	break;
    else
    {
    	UCA0TXBUF=*data_point;
    	data_point++;
  	}
  }
}

//******************************************************************************
// : 鸴λַǷΪ0xffff
// : 
// : λַݲΪ0xffff,򷵻1.
unsigned char ResetVectorValid(void)
{
  if(ReadFlash(RESETVECTORADDR_APP)==0xff&&
     ReadFlash(RESETVECTORADDR_APP+1)==0xff) //ӦóĸλΪ0xffff,ʾûӦó
  {
    return 0;
  }
  return 1;
}

//******************************************************************************
// : UART0ʼ,9600λ/,8λַ,1λֹͣλ,У.
// :   : 
// ˵һ,9600,ʱԴѡΪACLK.ʿܻЩ.ûҪԽѡ
// ƵʱԴ.ӦҪԼ޸.ѡƵʱӻʹʵʼ.
void InitUart(void)
{ 
    P3SEL |= BIT3 + BIT4;                             // P3.3,4 = USCI_A0 TXD/RXD
    UCA0CTL1 |= UCSWRST;                      // **Put state machine in reset**
    UCA0CTL1 |= UCSSEL_1;                     // CLK = ACLK
    UCA0BR0 = 0x0D;                           // 2400 (see User's Guide)
  UCA0BR1 = 0x00;                           //
  UCA0MCTL |= UCBRS_6+UCBRF_0;              // Modulation UCBRSx=6, UCBRFx=0

    UCA0CTL1 &= ~UCSWRST;                     // **Initialize USCI state machine**
    //UCA0IE |= UCRXIE;                         // Enable USCI_A0 RX interrupt
}

//******************************************************************************
// : FLASH
// : 16λ FLASHַ
// : 
void EraseFlash(unsigned int waddr)
{ 
      char i = 0;
      waddr = APP_START_ADDRESS;
      __disable_interrupt();                        // رж    
      for(i = 0;i < APP_SEG_NUM; i++)
      {
        FCTL3 = FWKEY;                           
        FCTL1 = FWKEY + ERASE;                //      
        *(unsigned char*)waddr=0;             // Ĳβ       
        while(FCTL3 & BUSY);
        waddr += FLASH_PAGE_SIZE;
      }
      FCTL3=FWKEY+LOCK;   
      
      __enable_interrupt();                     //ȫж
}

//******************************************************************************
// : FLASHд
// : unsigned int addr 16λ FLASHַ, unsigned char *pdata ָ
// : unsigned char length ݳ
// : unsigned char ־
unsigned char WriteFlash(unsigned int addr,unsigned char *pdata,
                unsigned char length)
{
    unsigned char ErrorFlag = 0;
    unsigned char i;
    
    while(FCTL3 & BUSY);
        
    __disable_interrupt();
        
    FCTL3 = FWKEY;                            // 
    FCTL1 = FWKEY + WRT;                      // WRTλΪд
    for(i=0;i<length;i++)
    {  
       *(unsigned char*)addr=*pdata;          // дһֽ
      /* if(ReadFlash(addr)!=*pdata)            // ֤,дȽ.ȷ 
       {  
         ErrorFlag = 1;                       // ô־                   
       }  */
       addr++;pdata++;                        
    }
    FCTL1=FWKEY;             
    FCTL3=FWKEY+LOCK;       

    __enable_interrupt();                     //ȫж
      
    return ErrorFlag;
}

//******************************************************************************
// : FLASH
// : unsigned int waddr 16λַ
// : unsigned char һֽ
unsigned char ReadFlash(unsigned int waddr)
{
  unsigned char value;
  while(FCTL3 & BUSY);
  value = *(unsigned char*)waddr;
  return value;
}

//******************************************************************************
// : жб
#pragma vector=RTC_VECTOR
__interrupt void intec_0(void)
{
  asm(" br &0xF9D2;");
}

#pragma vector=PORT2_VECTOR
__interrupt void intec_1(void)
{
  asm(" br &0xF9D4;");
}

#pragma vector=TIMER2_A1_VECTOR
__interrupt void intec_2(void)
{
  asm(" br &0xF9D6;");
}

#pragma vector=TIMER2_A0_VECTOR
__interrupt void intec_3(void)
{
  asm(" br &0xF9D8;");
}


#pragma vector=USCI_B1_VECTOR
__interrupt void intec_4(void)
{
  asm(" br &0xF9DA;");
}

#pragma vector=USCI_A1_VECTOR
__interrupt void intec_5(void)
{
  asm(" br &0xF9DC;");  
}

#pragma vector=PORT1_VECTOR
__interrupt void intec_6(void)
{
  asm(" br &0xF9DE;");
}

#pragma vector=TIMER1_A1_VECTOR
__interrupt void intec_7(void)
{
  asm(" br &0xF9E0;");
}

#pragma vector=TIMER1_A0_VECTOR
__interrupt void intec_8(void)
{
  asm(" br &0xF9E2;");
}

#pragma vector=DMA_VECTOR
__interrupt void intec_9(void)              // ӦóĴж0жַ
{
  asm(" br &0xF9E4;");
}


//0xF9E6  Reserved

#pragma vector=TIMER0_A1_VECTOR
__interrupt void intec_10(void)
{
  asm(" br &0xF9E8;");
}

#pragma vector=TIMER0_A0_VECTOR
__interrupt void intec_11(void)
{
  asm(" br &0xF9EA;");
}

#pragma vector=ADC12_VECTOR
__interrupt void intec_12(void)
{
  asm(" br &0xF9EC;");
}

#pragma vector=USCI_B0_VECTOR
__interrupt void intec_13(void)
{
  asm(" br &0xF9EE;");
}

#pragma vector=USCI_A0_VECTOR
__interrupt void intec_14(void)
{
  asm(" br &0xF9F0;");
}


#pragma vector=WDT_VECTOR
__interrupt void intec_15(void)
{
  asm(" br &0xF9F2;");
}


#pragma vector=TIMER0_B1_VECTOR
__interrupt void intec_16(void)
{
  asm(" br &0xF9F4;");
}


#pragma vector=TIMER0_B0_VECTOR
__interrupt void intec_17(void)
{
  asm(" br &0xF9F6;");
}


#pragma vector=COMP_B_VECTOR
__interrupt void intec_18(void)
{
  asm(" br &0xF9F8;");
}


#pragma vector=UNMI_VECTOR
__interrupt void intec_19(void)
{
  asm(" br &0xF9FA;");
}

/*
#pragma vector=SYSNMI_VECTOR
__interrupt void intec_20(void)
{
  asm(" br &0xF9FC;");
}

*/
